--[[
Copyright (c) 2010-2015 Matthias Richter

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Except as contained in this notice, the name(s) of the above copyright holders
shall not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]--
local c=(...):match("^(.*[%./])[^%.%/]+$")or""local s,A=math.cos,math.sin local u={}u.__index=u u.smooth={}function u.smooth.none()return function(c,s)return c,s end end function u.smooth.linear(c)assert(type(c)=="number","Invalid parameter: speed = "..tostring(c))return function(s,A,u)local l=math.sqrt(s*s+A*A)local b=math.min((u or c)*love.timer.getDelta(),l)if l>0 then s,A=s/l,A/l end return s*b,A*b end end function u.smooth.damped(c)assert(type(c)=="number","Invalid parameter: stiffness = "..tostring(c))return function(s,A,u)local l=love.timer.getDelta()*(u or c)return s*l,A*l end end local function l(c,s,A,l,b)c,s=c or love.graphics.getWidth()/2,s or love.graphics.getHeight()/2 A=A or 1 l=l or 0 b=b or u.smooth.none()return setmetatable({x=c,y=s;scale=A,rot=l,smoother=b},u)end function u.lookAt(A,c,s)A.x,A.y=c,s return A end function u.move(A,c,s)A.x,A.y=A.x+c,A.y+s return A end function u.position(c)return c.x,c.y end function u.rotate(s,c)s.rot=s.rot+c return s end function u.rotateTo(s,c)s.rot=c return s end function u.zoom(s,c)s.scale=s.scale*c return s end function u.zoomTo(s,c)s.scale=c return s end function u.attach(b,c,s,A,u,l)c,s=c or 0,s or 0 A,u=A or love.graphics.getWidth(),u or love.graphics.getHeight()b._sx,b._sy,b._sw,b._sh=love.graphics.getScissor()if not l then love.graphics.setScissor(c,s,A,u)end local z,g=c+A/2,s+u/2 love.graphics.push()love.graphics.translate(z,g)love.graphics.scale(b.scale)love.graphics.rotate(b.rot)love.graphics.translate(-b.x,-b.y)end function u.detach(c)love.graphics.pop()love.graphics.setScissor(c._sx,c._sy,c._sw,c._sh)end function u.draw(c,...)local s,A,u,l,b,z local g=select("#",...)if g==1 then z=...elseif g==5 then s,A,u,l,z=...elseif g==6 then s,A,u,l,b,z=...else error("Invalid arguments to camera:draw()")end c:attach(s,A,u,l,b)z()c:detach()end function u.cameraCoords(V,c,u,l,b,z,g)l,b=l or 0,b or 0 z,g=z or love.graphics.getWidth(),g or love.graphics.getHeight()local Z,P=s(V.rot),A(V.rot)c,u=c-V.x,u-V.y c,u=Z*c-P*u,P*c+Z*u return(c*V.scale+z/2)+l,(u*V.scale+g/2)+b end function u.worldCoords(V,c,u,l,b,z,g)l,b=l or 0,b or 0 z,g=z or love.graphics.getWidth(),g or love.graphics.getHeight()local Z,P=s(-V.rot),A(-V.rot)c,u=((c-z/2)-l)/V.scale,((u-g/2)-b)/V.scale c,u=Z*c-P*u,P*c+Z*u return c+V.x,u+V.y end function u.mousePosition(l,c,s,A,u)local b,z=love.mouse.getPosition()return l:worldCoords(b,z,c,s,A,u)end function u.lockX(A,c,s,...)local u,l=(s or A.smoother)(c-A.x,A.y,...)A.x=A.x+u return A end function u.lockY(A,c,s,...)local u,l=(s or A.smoother)(A.x,c-A.y,...)A.y=A.y+l return A end function u.lockPosition(u,c,s,A,...)return u:move((A or u.smoother)(c-u.x,s-u.y,...))end function u.lockWindow(Z,c,u,l,b,z,g,V,...)c,u=Z:cameraCoords(c,u)local P,D=0,0 if c<l then P=c-l elseif c>b then P=c-b end if u<z then D=u-z elseif u>g then D=u-g end local N,Y=s(-Z.rot),A(-Z.rot)P,D=(N*P-Y*D)/Z.scale,(Y*P+N*D)/Z.scale Z:move((V or Z.smoother)(P,D,...))end return setmetatable({new=l,smooth=u.smooth},{__call=function(c,...)return l(...)end})
