--[[
Copyright (c) 2010-2013 Matthias Richter

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Except as contained in this notice, the name(s) of the above copyright holders
shall not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]--
local v=assert local p,u,d,r=math.sqrt,math.cos,math.sin,math.atan2 local Z={}Z.__index=Z local function Q(v,p)return setmetatable({x=v or 0;y=p or 0},Z)end local I=Q(0,0)local function D(v,p)p=p or 1 return Q(u(v)*p,d(v)*p)end local function a(p,u)p=p or 1 u=u or p v(u>0,"len_max must be greater than zero")v(u>=p,"len_max must be greater than or equal to len_min")return D((math.random()*2)*math.pi,math.random()*(u-p)+p)end local function o(v)return type(v)=="table"and(type(v.x)=="number"and type(v.y)=="number")end function Z.clone(v)return Q(v.x,v.y)end function Z.unpack(v)return v.x,v.y end function Z.__tostring(v)return"("..(tonumber(v.x)..(","..(tonumber(v.y)..")")))end function Z.__unm(v)return Q(-v.x,-v.y)end function Z.__add(p,u)v(o(p)and o(u),"Add: wrong argument types (<vector> expected)")return Q(p.x+u.x,p.y+u.y)end function Z.__sub(p,u)v(o(p)and o(u),"Sub: wrong argument types (<vector> expected)")return Q(p.x-u.x,p.y-u.y)end function Z.__mul(p,u)if type(p)=="number"then return Q(p*u.x,p*u.y)elseif type(u)=="number"then return Q(u*p.x,u*p.y)else v(o(p)and o(u),"Mul: wrong argument types (<vector> or <number> expected)")return p.x*u.x+p.y*u.y end end function Z.__div(p,u)v(o(p)and type(u)=="number","wrong argument types (expected <vector> / <number>)")return Q(p.x/u,p.y/u)end function Z.__eq(v,p)return v.x==p.x and v.y==p.y end function Z.__lt(v,p)return v.x<p.x or v.x==p.x and v.y<p.y end function Z.__le(v,p)return v.x<=p.x and v.y<=p.y end function Z.permul(p,u)v(o(p)and o(u),"permul: wrong argument types (<vector> expected)")return Q(p.x*u.x,p.y*u.y)end function Z.toPolar(v)return Q(r(v.x,v.y),v:len())end function Z.len2(v)return v.x*v.x+v.y*v.y end function Z.len(v)return p(v.x*v.x+v.y*v.y)end function Z.dist(u,d)v(o(u)and o(d),"dist: wrong argument types (<vector> expected)")local r=u.x-d.x local Z=u.y-d.y return p(r*r+Z*Z)end function Z.dist2(p,u)v(o(p)and o(u),"dist: wrong argument types (<vector> expected)")local d=p.x-u.x local r=p.y-u.y return d*d+r*r end function Z.normalizeInplace(v)local p=v:len()if p>0 then v.x,v.y=v.x/p,v.y/p end return v end function Z.normalized(v)return(v:clone()):normalizeInplace()end function Z.rotateInplace(p,v)local r,Z=u(v),d(v)p.x,p.y=r*p.x-Z*p.y,Z*p.x+r*p.y return p end function Z.rotated(p,v)local r,Z=u(v),d(v)return Q(r*p.x-Z*p.y,Z*p.x+r*p.y)end function Z.perpendicular(v)return Q(-v.y,v.x)end function Z.projectOn(u,p)v(o(p),"invalid argument: cannot project vector on "..type(p))local d=(u.x*p.x+u.y*p.y)/(p.x*p.x+p.y*p.y)return Q(d*p.x,d*p.y)end function Z.mirrorOn(u,p)v(o(p),"invalid argument: cannot mirror vector on "..type(p))local d=(2*(u.x*p.x+u.y*p.y))/(p.x*p.x+p.y*p.y)return Q(d*p.x-u.x,d*p.y-u.y)end function Z.cross(u,p)v(o(p),"cross: wrong argument types (<vector> expected)")return u.x*p.y-u.y*p.x end function Z.trimInplace(p,v)local u=(v*v)/p:len2()u=u>1 and 1 or math.sqrt(u)p.x,p.y=p.x*u,p.y*u return p end function Z.angleTo(p,v)if v then return r(p.y,p.x)-r(v.y,v.x)end return r(p.y,p.x)end function Z.trimmed(p,v)return(p:clone()):trimInplace(v)end return setmetatable({new=Q,fromPolar=D;randomDirection=a,isvector=o;zero=I},{__call=function(v,...)return Q(...)end})
